--- old/usr/src/uts/common/io/aac/aac.c	Thu Nov  1 14:48:24 2012
+++ new/usr/src/uts/common/io/aac/aac.c	Thu Nov  1 14:48:24 2012
@@ -5743,28 +5719,18 @@
 	    sizeof (((struct aac_synchronize_reply *)0)->Data));
 }
 
-/*
- * Start/Stop unit (Power Management)
- */
 static void
-aac_cmd_fib_startstop(struct aac_softstate *softs, struct aac_cmd *acp)
+aac_cmd_aif_request(struct aac_softstate *softs, struct aac_cmd *acp)
 {
-	ddi_acc_handle_t acc = acp->slotp->fib_acc_handle;
-	struct aac_Container *cmd =
-	    (struct aac_Container *)&acp->slotp->fibp->data[0];
-	union scsi_cdb *cdbp = (void *)acp->pkt->pkt_cdbp;
+	struct aac_slot *slotp = acp->slotp;
+	ddi_acc_handle_t acc = slotp->fib_acc_handle;
+	struct aac_aif_command *aif =
+	    (struct aac_aif_command *)&slotp->fibp->data[0];
 
-	acp->fib_size = AAC_FIB_SIZEOF(struct aac_Container);
+	acp->fib_size = sizeof(struct aac_fib);
 
-	aac_cmd_fib_header(softs, acp, ContainerCommand);
-	bzero(cmd, sizeof (*cmd) - CT_PACKET_SIZE);
-	ddi_put32(acc, &cmd->Command, VM_ContainerConfig);
-	ddi_put32(acc, &cmd->CTCommand.command, CT_PM_DRIVER_SUPPORT);
-	ddi_put32(acc, &cmd->CTCommand.param[0], cdbp->cdb_opaque[4] & 1 ? \
-	    AAC_PM_DRIVERSUP_START_UNIT : AAC_PM_DRIVERSUP_STOP_UNIT);
-	ddi_put32(acc, &cmd->CTCommand.param[1],
-	    ((struct aac_container *)acp->dvp)->cid);
-	ddi_put32(acc, &cmd->CTCommand.param[2], cdbp->cdb_opaque[1] & 1);
+	aac_cmd_fib_header(softs, slotp, AifRequest, acp->fib_size);
+	ddi_put32(acc, (uint32_t *)&aif->command, AifReqEvent);
 }
 
 /*
@@ -5773,8 +5739,9 @@
 static void
 aac_cmd_fib_srb(struct aac_cmd *acp)
 {
-	ddi_acc_handle_t acc = acp->slotp->fib_acc_handle;
-	struct aac_srb *srb = (struct aac_srb *)&acp->slotp->fibp->data[0];
+	struct aac_slot *slotp = acp->slotp;
+	ddi_acc_handle_t acc = slotp->fib_acc_handle;
+	struct aac_srb *srb = (struct aac_srb *)&slotp->fibp->data[0];
 	uint8_t *cdb;
 
 	ddi_put32(acc, &srb->function, SRBF_ExecuteScsi);
@@ -5816,7 +5783,7 @@
 	    acp->left_cookien * sizeof (struct aac_sg_entry);
 
 	/* Fill FIB and SRB headers, and copy cdb */
-	aac_cmd_fib_header(softs, acp, ScsiPortCommand);
+	aac_cmd_fib_header(softs, acp->slotp, ScsiPortCommand, acp->fib_size);
 	aac_cmd_fib_srb(acp);
 
 	/* Fill SG table */
@@ -5843,7 +5810,8 @@
 	    acp->left_cookien * sizeof (struct aac_sg_entry64);
 
 	/* Fill FIB and SRB headers, and copy cdb */
-	aac_cmd_fib_header(softs, acp, ScsiPortCommandU64);
+	aac_cmd_fib_header(softs, acp->slotp, ScsiPortCommandU64,
+	    acp->fib_size);
 	aac_cmd_fib_srb(acp);
 
 	/* Fill SG table */
@@ -5864,12 +5832,20 @@
 {
 	struct aac_slot *slotp;
 
+	if ((softs->flags & AAC_FLAGS_SYNC_MODE) &&
+		softs->sync_slot_busy)
+		return (AACERR);
+
 	if (slotp = aac_get_slot(softs)) {
 		acp->slotp = slotp;
 		slotp->acp = acp;
 		acp->aac_cmd_fib(softs, acp);
 		(void) ddi_dma_sync(slotp->fib_dma_handle, 0, 0,
-		    DDI_DMA_SYNC_FORDEV);
+			DDI_DMA_SYNC_FORDEV);
+		if (softs->flags & AAC_FLAGS_SYNC_MODE) {
+			softs->sync_slot_busy = 1;
+			softs->sync_mode_slot = slotp;
+		}
 		return (AACOK);
 	}
 	return (AACERR);
@@ -5881,55 +5857,25 @@
 	struct aac_device *dvp = acp->dvp;
 	int q = AAC_CMDQ(acp);
 
-	if (softs->bus_ncmds[q] < softs->bus_throttle[q]) {
-		if (dvp) {
-			if (dvp->ncmds[q] < dvp->throttle[q]) {
-				if (!(acp->flags & AAC_CMD_NTAG) ||
-				    dvp->ncmds[q] == 0) {
-					return (aac_cmd_slot_bind(softs, acp));
-				}
-				ASSERT(q == AAC_CMDQ_ASYNC);
-				aac_set_throttle(softs, dvp, AAC_CMDQ_ASYNC,
-				    AAC_THROTTLE_DRAIN);
+	if (dvp) {
+		if (dvp->ncmds[q] < dvp->throttle[q]) {
+			if (!(acp->flags & AAC_CMD_NTAG) ||
+			    dvp->ncmds[q] == 0) {
+do_bind:
+				return (aac_cmd_slot_bind(softs, acp));
 			}
-		} else {
-			return (aac_cmd_slot_bind(softs, acp));
+			ASSERT(q == AAC_CMDQ_ASYNC);
+			aac_set_throttle(softs, dvp, AAC_CMDQ_ASYNC,
+			    AAC_THROTTLE_DRAIN);
 		}
+	} else {
+		if (softs->bus_ncmds[q] < softs->bus_throttle[q])
+			goto do_bind;
 	}
 	return (AACERR);
 }
 
-static int
-aac_sync_fib_slot_bind(struct aac_softstate *softs, struct aac_cmd *acp)
-{
-	struct aac_slot *slotp;
-
-	while (softs->sync_ac.slotp)
-		cv_wait(&softs->sync_fib_cv, &softs->io_lock);
-
-	if (slotp = aac_get_slot(softs)) {
-		ASSERT(acp->slotp == NULL);
-
-		acp->slotp = slotp;
-		slotp->acp = acp;
-		return (AACOK);
-	}
-	return (AACERR);
-}
-
 static void
-aac_sync_fib_slot_release(struct aac_softstate *softs, struct aac_cmd *acp)
-{
-	ASSERT(acp->slotp);
-
-	aac_release_slot(softs, acp->slotp);
-	acp->slotp->acp = NULL;
-	acp->slotp = NULL;
-
-	cv_signal(&softs->sync_fib_cv);
-}
-
-static void
 aac_start_io(struct aac_softstate *softs, struct aac_cmd *acp)
 {
 	struct aac_slot *slotp = acp->slotp;
@@ -5949,10 +5895,13 @@
 	softs->bus_ncmds[q]++;
 	aac_cmd_enqueue(&softs->q_busy, acp);
 
-	AACDB_PRINT_FIB(softs, slotp);
 
-	if (softs->flags & AAC_FLAGS_NEW_COMM) {
-		rval = aac_send_command(softs, slotp);
+	if (softs->flags & AAC_FLAGS_SYNC_MODE) {
+		uint32_t wait = 0;
+		rval = aac_sync_mbcommand(softs, AAC_MONKER_SYNCFIB,
+			slotp->fib_phyaddr, 0, 0, 0, &wait, NULL);
+	} else if (softs->flags & AAC_FLAGS_NEW_COMM) {
+		rval = AAC_SEND_COMMAND(softs, slotp);
 	} else {
 		/*
 		 * If fib can not be enqueued, the adapter is in an abnormal
@@ -5963,7 +5912,7 @@
 	}
 
 	if (aac_check_dma_handle(slotp->fib_dma_handle) != DDI_SUCCESS)
-		ddi_fm_service_impact(softs->devinfo_p, DDI_SERVICE_UNAFFECTED);
+		aac_fm_service_impact(softs->devinfo_p, DDI_SERVICE_UNAFFECTED);
 
 	/*
 	 * NOTE: We send command only when slots availabe, so should never
@@ -6033,7 +5982,7 @@
 				if ((acp->flags & AAC_CMD_CONSISTENT) &&
 				    (acp->flags & AAC_CMD_BUF_READ)) {
 					if (aac_dma_sync_ac(acp) != AACOK) {
-						ddi_fm_service_impact(
+						aac_fm_service_impact(
 						    softs->devinfo_p,
 						    DDI_SERVICE_UNAFFECTED);
 						pkt->pkt_reason = CMD_TRAN_ERR;
@@ -6043,23 +5992,23 @@
 				if ((aac_check_acc_handle(softs-> \
 				    comm_space_acc_handle) != DDI_SUCCESS) ||
 				    (aac_check_acc_handle(softs-> \
-				    pci_mem_handle) != DDI_SUCCESS)) {
-					ddi_fm_service_impact(softs->devinfo_p,
+				    pci_mem_handle[0]) != DDI_SUCCESS)) {
+					aac_fm_service_impact(softs->devinfo_p,
 					    DDI_SERVICE_UNAFFECTED);
-					ddi_fm_acc_err_clear(softs-> \
-					    pci_mem_handle, DDI_FME_VER0);
+					aac_fm_acc_err_clear(softs-> \
+					    pci_mem_handle[0], DDI_FME_VER0);
 					pkt->pkt_reason = CMD_TRAN_ERR;
 					pkt->pkt_statistics = 0;
 				}
 				if (aac_check_dma_handle(softs-> \
 				    comm_space_dma_handle) != DDI_SUCCESS) {
-					ddi_fm_service_impact(softs->devinfo_p,
+					aac_fm_service_impact(softs->devinfo_p,
 					    DDI_SERVICE_UNAFFECTED);
 					pkt->pkt_reason = CMD_TRAN_ERR;
 					pkt->pkt_statistics = 0;
 				}
 			}
-			scsi_hba_pkt_comp(pkt);
+			(*pkt->pkt_comp)(pkt);
 		} else {
 			break;
 		}
@@ -6069,7 +6018,7 @@
 static int
 aac_alloc_fib(struct aac_softstate *softs, struct aac_slot *slotp)
 {
-	size_t rlen;
+	size_t rlen, maxsize;
 	ddi_dma_cookie_t cookie;
 	uint_t cookien;
 
@@ -6084,10 +6033,17 @@
 		    "Cannot alloc dma handle for slot fib area");
 		goto error;
 	}
+
+	if (softs->flags & AAC_FLAGS_NEW_COMM_TYPE1) 
+		maxsize = softs->aac_max_fib_size + sizeof(struct aac_fib_xporthdr) + 31;
+	else if (softs->flags & AAC_FLAGS_NEW_COMM_TYPE2) 
+		maxsize = softs->aac_max_fib_size + 31;
+	else
+		maxsize = softs->aac_max_fib_size;
 	if (ddi_dma_mem_alloc(
 	    slotp->fib_dma_handle,
-	    softs->aac_max_fib_size,
-	    &softs->acc_attr,
+	    maxsize,
+	    &aac_acc_attr,
 	    DDI_DMA_RDWR | DDI_DMA_CONSISTENT,
 	    DDI_DMA_SLEEP,
 	    NULL,
@@ -6102,7 +6058,7 @@
 	    slotp->fib_dma_handle,
 	    NULL,
 	    (caddr_t)slotp->fibp,
-	    softs->aac_max_fib_size,
+	    maxsize,
 	    DDI_DMA_RDWR | DDI_DMA_CONSISTENT,
 	    DDI_DMA_SLEEP,
 	    NULL,
@@ -6115,17 +6071,32 @@
 
 	/* Check dma handles allocated in fib attach */
 	if (aac_check_dma_handle(slotp->fib_dma_handle) != DDI_SUCCESS) {
-		ddi_fm_service_impact(softs->devinfo_p, DDI_SERVICE_LOST);
+		aac_fm_service_impact(softs->devinfo_p, DDI_SERVICE_LOST);
 		goto error;
 	}
 
 	/* Check acc handles allocated in fib attach */
 	if (aac_check_acc_handle(slotp->fib_acc_handle) != DDI_SUCCESS) {
-		ddi_fm_service_impact(softs->devinfo_p, DDI_SERVICE_LOST);
+		aac_fm_service_impact(softs->devinfo_p, DDI_SERVICE_LOST);
 		goto error;
 	}
 
 	slotp->fib_phyaddr = cookie.dmac_laddress;
+	if (softs->flags & AAC_FLAGS_NEW_COMM_TYPE1) {
+		uint64_t fibphys_aligned;
+		fibphys_aligned = 
+			(slotp->fib_phyaddr + sizeof(struct aac_fib_xporthdr) + 31) & ~31;
+		slotp->fibp = (struct aac_fib *)
+			((uint8_t *)slotp->fibp + (fibphys_aligned - slotp->fib_phyaddr));
+		slotp->fib_phyaddr = fibphys_aligned;
+	} else if (softs->flags & AAC_FLAGS_NEW_COMM_TYPE2) {
+		uint64_t fibphys_aligned;
+		fibphys_aligned = 
+			(slotp->fib_phyaddr + 31) & ~31;
+		slotp->fibp = (struct aac_fib *)
+			((uint8_t *)slotp->fibp + (fibphys_aligned - slotp->fib_phyaddr));
+		slotp->fib_phyaddr = fibphys_aligned;
+	}
 	return (AACOK);
 
 error:
@@ -6169,6 +6140,7 @@
 		aac_release_slot(softs, slotp);
 		softs->total_fibs++;
 	}
+	aac_alloc_fib(softs, softs->sync_slot);
 }
 
 static void
@@ -6184,6 +6156,7 @@
 		softs->total_fibs--;
 	}
 	ASSERT(softs->total_fibs == 0);
+	aac_free_fib(softs->sync_slot);
 }
 
 static int
@@ -6192,8 +6165,12 @@
 	int i;
 
 	softs->total_slots = softs->aac_max_fibs;
+	/* FIXME: patch max. outstanding commands */
+	if (softs->total_slots > 1) 
+		softs->total_slots -= 1;
+
 	softs->io_slot = kmem_zalloc(sizeof (struct aac_slot) * \
-	    softs->total_slots, KM_SLEEP);
+	    (softs->total_slots + 1), KM_SLEEP);
 	if (softs->io_slot == NULL) {
 		AACDB_PRINT(softs, CE_WARN, "Cannot allocate slot");
 		return (AACERR);
@@ -6202,6 +6179,7 @@
 		softs->io_slot[i].index = i;
 	softs->free_io_slot_head = NULL;
 	softs->total_fibs = 0;
+	softs->sync_slot = &softs->io_slot[softs->total_slots];
 	return (AACOK);
 }
 
@@ -6211,9 +6189,10 @@
 	ASSERT(softs->free_io_slot_head == NULL);
 
 	kmem_free(softs->io_slot, sizeof (struct aac_slot) * \
-	    softs->total_slots);
+	    (softs->total_slots + 1));
 	softs->io_slot = NULL;
 	softs->total_slots = 0;
+	softs->sync_slot = NULL;
 }
 
 struct aac_slot *
@@ -6271,8 +6250,14 @@
 	/*
 	 * Interrupt is disabled, we have to poll the adapter by ourselves.
 	 */
-	intr_handler = (softs->flags & AAC_FLAGS_NEW_COMM) ?
-	    aac_process_intr_new : aac_process_intr_old;
+	if ((softs->flags & AAC_FLAGS_NEW_COMM_TYPE1) || 
+		(softs->flags & AAC_FLAGS_NEW_COMM_TYPE2) ||
+		(softs->flags & AAC_FLAGS_NEW_COMM_TYPE34))
+		intr_handler = aac_process_intr_new_type1;
+	else if (softs->flags & AAC_FLAGS_NEW_COMM) 
+		intr_handler = aac_process_intr_new;
+	else
+		intr_handler = aac_process_intr_old;
 	while (!(acp->flags & (AAC_CMD_CMPLT | AAC_CMD_ABORT))) {
 		int i = AAC_POLL_TIME * 1000;
 
@@ -6304,140 +6289,44 @@
 static int
 aac_dma_sync_ac(struct aac_cmd *acp)
 {
-	if (acp->buf_dma_handle) {
+	uint_t i;
+	uint32_t offset;
+	int rval = AACOK;
+
+	for (i = 0, offset = 0; i < acp->segment_cnt; ++i) {
+		if (!acp->segments[i].buf_dma_handle) {
+			offset += acp->segments[i].abp_size;
+			continue;
+		}
 		if (acp->flags & AAC_CMD_BUF_WRITE) {
-			if (acp->abp != NULL)
-				ddi_rep_put8(acp->abh,
-				    (uint8_t *)acp->bp->b_un.b_addr,
-				    (uint8_t *)acp->abp, acp->bp->b_bcount,
-				    DDI_DEV_AUTOINCR);
-			(void) ddi_dma_sync(acp->buf_dma_handle, 0, 0,
-			    DDI_DMA_SYNC_FORDEV);
+			if (acp->segments[i].abp != NULL) {
+				ddi_rep_put8(acp->segments[i].abh,
+					(uint8_t *)acp->bp->b_un.b_addr + offset,
+					(uint8_t *)acp->segments[i].abp, 
+					acp->segments[i].abp_size,
+					DDI_DEV_AUTOINCR);
+			}
+			(void) ddi_dma_sync(acp->segments[i].buf_dma_handle, 
+				0, 0, DDI_DMA_SYNC_FORDEV);
 		} else {
-			(void) ddi_dma_sync(acp->buf_dma_handle, 0, 0,
-			    DDI_DMA_SYNC_FORCPU);
-			if (aac_check_dma_handle(acp->buf_dma_handle) !=
-			    DDI_SUCCESS)
-				return (AACERR);
-			if (acp->abp != NULL)
-				ddi_rep_get8(acp->abh,
-				    (uint8_t *)acp->bp->b_un.b_addr,
-				    (uint8_t *)acp->abp, acp->bp->b_bcount,
-				    DDI_DEV_AUTOINCR);
-		}
-	}
-	return (AACOK);
-}
-
-/*
- * Copy AIF from adapter to the empty AIF slot and inform AIF threads
- */
-static void
-aac_save_aif(struct aac_softstate *softs, ddi_acc_handle_t acc,
-    struct aac_fib *fibp0, int fib_size0)
-{
-	struct aac_fib *fibp;	/* FIB in AIF queue */
-	int fib_size;
-	uint16_t fib_command;
-	int current, next;
-
-	/* Ignore non AIF messages */
-	fib_command = ddi_get16(acc, &fibp0->Header.Command);
-	if (fib_command != AifRequest) {
-		cmn_err(CE_WARN, "!Unknown command from controller");
-		return;
-	}
-
-	mutex_enter(&softs->aifq_mutex);
-
-	/* Save AIF */
-	fibp = &softs->aifq[softs->aifq_idx].d;
-	fib_size = (fib_size0 > AAC_FIB_SIZE) ? AAC_FIB_SIZE : fib_size0;
-	ddi_rep_get8(acc, (uint8_t *)fibp, (uint8_t *)fibp0, fib_size,
-	    DDI_DEV_AUTOINCR);
-
-	if (aac_check_acc_handle(softs->pci_mem_handle) != DDI_SUCCESS) {
-		ddi_fm_service_impact(softs->devinfo_p,
-		    DDI_SERVICE_UNAFFECTED);
-		mutex_exit(&softs->aifq_mutex);
-		return;
-	}
-
-	AACDB_PRINT_AIF(softs, (struct aac_aif_command *)&fibp->data[0]);
-
-	/* Modify AIF contexts */
-	current = softs->aifq_idx;
-	next = (current + 1) % AAC_AIFQ_LENGTH;
-	if (next == 0) {
-		struct aac_fib_context *ctx_p;
-
-		softs->aifq_wrap = 1;
-		for (ctx_p = softs->fibctx_p; ctx_p; ctx_p = ctx_p->next) {
-			if (next == ctx_p->ctx_idx) {
-				ctx_p->ctx_flags |= AAC_CTXFLAG_FILLED;
-			} else if (current == ctx_p->ctx_idx &&
-			    (ctx_p->ctx_flags & AAC_CTXFLAG_FILLED)) {
-				ctx_p->ctx_idx = next;
-				ctx_p->ctx_overrun++;
+			(void) ddi_dma_sync(acp->segments[i].buf_dma_handle, 
+				0, 0, DDI_DMA_SYNC_FORCPU);
+			if (aac_check_dma_handle(acp->segments[i].buf_dma_handle) !=
+			    DDI_SUCCESS) {
+				rval = AACERR;
+			} else if (acp->segments[i].abp != NULL) {
+				ddi_rep_get8(acp->segments[i].abh,
+					(uint8_t *)acp->bp->b_un.b_addr + offset,
+					(uint8_t *)acp->segments[i].abp, 
+					acp->segments[i].abp_size,
+					DDI_DEV_AUTOINCR);
 			}
 		}
+		offset += acp->segments[i].abp_size;
 	}
-	softs->aifq_idx = next;
-
-	/* Wakeup AIF threads */
-	cv_broadcast(&softs->aifq_cv);
-	mutex_exit(&softs->aifq_mutex);
-
-	/* Wakeup event thread to handle aif */
-	aac_event_disp(softs, AAC_EVENT_AIF);
-}
-
-static int
-aac_return_aif_common(struct aac_softstate *softs, struct aac_fib_context *ctx,
-    struct aac_fib **fibpp)
-{
-	int current;
-
-	current = ctx->ctx_idx;
-	if (current == softs->aifq_idx &&
-	    !(ctx->ctx_flags & AAC_CTXFLAG_FILLED))
-		return (EAGAIN); /* Empty */
-
-	*fibpp = &softs->aifq[current].d;
-
-	ctx->ctx_flags &= ~AAC_CTXFLAG_FILLED;
-	ctx->ctx_idx = (current + 1) % AAC_AIFQ_LENGTH;
-	return (0);
-}
-
-int
-aac_return_aif(struct aac_softstate *softs, struct aac_fib_context *ctx,
-    struct aac_fib **fibpp)
-{
-	int rval;
-
-	mutex_enter(&softs->aifq_mutex);
-	rval = aac_return_aif_common(softs, ctx, fibpp);
-	mutex_exit(&softs->aifq_mutex);
 	return (rval);
 }
 
-int
-aac_return_aif_wait(struct aac_softstate *softs, struct aac_fib_context *ctx,
-    struct aac_fib **fibpp)
-{
-	int rval;
-
-	mutex_enter(&softs->aifq_mutex);
-	rval = aac_return_aif_common(softs, ctx, fibpp);
-	if (rval == EAGAIN) {
-		AACDB_PRINT(softs, CE_NOTE, "Waiting for AIF");
-		rval = cv_wait_sig(&softs->aifq_cv, &softs->aifq_mutex);
-	}
-	mutex_exit(&softs->aifq_mutex);
-	return ((rval > 0) ? 0 : EINTR);
-}
-
 /*
  * The following function comes from Adaptec:
  *
@@ -6449,26 +6338,37 @@
  * another particular event. When sees that events come in, it will do rescan.
  */
 static int
-aac_handle_aif(struct aac_softstate *softs, struct aac_aif_command *aif)
+aac_handle_aif(struct aac_softstate *softs, struct aac_fib *fibp)
 {
 	ddi_acc_handle_t acc = softs->comm_space_acc_handle;
+	uint16_t fib_command;
+	struct aac_aif_command *aif;
 	int en_type;
 	int devcfg_needed;
-	int cid;
-	uint32_t bus_id, tgt_id;
-	enum aac_cfg_event event = AAC_CFG_NULL_EXIST;
+	int current, next;
 
+	fib_command = LE_16(fibp->Header.Command);
+	if (fib_command != AifRequest) {
+		cmn_err(CE_NOTE, "!Unknown command from controller: 0x%x",
+		    fib_command);
+		return (AACERR);
+	}
+
+	/* Update internal container state */
+	aif = (struct aac_aif_command *)&fibp->data[0];
+
+	AACDB_PRINT_AIF(softs, aif);
 	devcfg_needed = 0;
 	en_type = LE_32((uint32_t)aif->data.EN.type);
 
 	switch (LE_32((uint32_t)aif->command)) {
 	case AifCmdDriverNotify: {
-		cid = LE_32(aif->data.EN.data.ECC.container[0]);
+		int cid = LE_32(aif->data.EN.data.ECC.container[0]);
 
 		switch (en_type) {
 		case AifDenMorphComplete:
 		case AifDenVolumeExtendComplete:
-			if (AAC_DEV_IS_VALID(&softs->containers[cid].dev))
+			if (cid < AAC_MAX_LD && softs->containers[cid].dev.valid)
 				softs->devcfg_wait_on = AifEnConfigChange;
 			break;
 		}
@@ -6478,7 +6378,6 @@
 	}
 
 	case AifCmdEventNotify:
-		cid = LE_32(aif->data.EN.data.ECC.container[0]);
 		switch (en_type) {
 		case AifEnAddContainer:
 		case AifEnDeleteContainer:
@@ -6494,18 +6393,9 @@
 				devcfg_needed = 1;
 			break;
 		case AifEnAddJBOD:
-			if (!(softs->flags & AAC_FLAGS_JBOD))
-				return (AACERR);
-			event = AAC_CFG_ADD;
-			bus_id = (cid >> 24) & 0xf;
-			tgt_id = cid & 0xffff;
-			break;
 		case AifEnDeleteJBOD:
-			if (!(softs->flags & AAC_FLAGS_JBOD))
-				return (AACERR);
-			event = AAC_CFG_DELETE;
-			bus_id = (cid >> 24) & 0xf;
-			tgt_id = cid & 0xffff;
+		case AifRawDeviceRemove:
+			timeout(aac_config_pd, softs, drv_usectohz(1000));
 			break;
 		}
 		if (softs->devcfg_wait_on == en_type)
@@ -6531,63 +6421,101 @@
 		break;
 	}
 
-	if (devcfg_needed) {
-		softs->devcfg_wait_on = 0;
+	if (devcfg_needed)
 		(void) aac_probe_containers(softs);
-	}
 
-	if (event != AAC_CFG_NULL_EXIST) {
-		ASSERT(en_type == AifEnAddJBOD || en_type == AifEnDeleteJBOD);
-		(void) aac_probe_jbod(softs,
-		    AAC_P2VTGT(softs, bus_id, tgt_id), event);
+	/* Modify AIF contexts */
+	current = softs->aifq_idx;
+	next = (current + 1) % AAC_AIFQ_LENGTH;
+	if (next == 0) {
+		struct aac_fib_context *ctx;
+
+		softs->aifq_wrap = 1;
+		for (ctx = softs->fibctx; ctx; ctx = ctx->next) {
+			if (next == ctx->ctx_idx) {
+				ctx->ctx_filled = 1;
+			} else if (current == ctx->ctx_idx && ctx->ctx_filled) {
+				ctx->ctx_idx = next;
+			}
+		}
 	}
+	softs->aifq_idx = next;
+
+	/* Wakeup applications */
+	cv_broadcast(&softs->aifv);
 	return (AACOK);
 }
 
-
 /*
- * Check and handle AIF events
+ * Timeout recovery
  */
 static void
-aac_aif_event(struct aac_softstate *softs)
+aac_cmd_timeout(struct aac_softstate *softs, struct aac_cmd *acp)
 {
-	struct aac_fib *fibp;
+	int rval;
 
-	/*CONSTCOND*/
-	while (1) {
-		if (aac_return_aif(softs, &softs->aifctx, &fibp) != 0)
-			break; /* No more AIFs to handle, end loop */
+	/* print timed out command */
+#ifdef AAC_DEBUG
+	{
+		struct aac_slot *slotp = acp->slotp;
+		ddi_acc_handle_t acc = slotp->fib_acc_handle;
+		uint16_t i, cmd, size;
+		uint8_t *dataptr;
+		uint8_t data[16];
+		uint32_t timeout;
 
-		/* AIF overrun, array create/delete may missed. */
-		if (softs->aifctx.ctx_overrun) {
-			softs->aifctx.ctx_overrun = 0;
+		timeout = acp->timeout - aac_timebase - aac_tick;
+		if (acp->ac_comp == aac_ld_complete) {
+			AACDB_PRINT(softs, CE_NOTE,
+				"Container command timed out, index %d timeout %d flags 0x%x id %d",
+				slotp->index, timeout, acp->flags,
+				((struct aac_container *)acp->dvp)->cid);
+		} else if (acp->ac_comp == aac_pd_complete) {
+			AACDB_PRINT(softs, CE_NOTE,
+				"Nondasd command timed out, index %d timeout %d flags 0x%x bus %d tid %d",
+				slotp->index, timeout, acp->flags,
+				((struct aac_nondasd *)acp->dvp)->bus,
+				((struct aac_nondasd *)acp->dvp)->tid);
+		} else if (acp->ac_comp == aac_ioctl_complete) {
+			AACDB_PRINT(softs, CE_NOTE,
+				"IOCTL command timed out, index %d timeout %d flags 0x%x",
+				slotp->index, timeout, acp->flags);
+		} else if (acp->ac_comp == aac_synccache_complete) {
+			AACDB_PRINT(softs, CE_NOTE,
+				"Flush command timed out, index %d timeout %d flags 0x%x",
+				slotp->index, timeout, acp->flags);
+		} else if (acp->ac_comp == aac_aifreq_complete) {
+			AACDB_PRINT(softs, CE_NOTE,
+				"AIF request command timed out, index %d timeout %d flags 0x%x",
+				slotp->index, timeout, acp->flags);
 		}
+		cmd = ddi_get16(acc, &slotp->fibp->Header.Command);
+		size = acp->fib_size - sizeof(struct aac_fib_header);
+		AACDB_PRINT(softs, CE_NOTE, "Fib command 0x%x size %d data:", 
+			cmd, size);
 
-		/* AIF received, handle it */
-		struct aac_aif_command *aifp =
-		    (struct aac_aif_command *)&fibp->data[0];
-		uint32_t aif_command = LE_32((uint32_t)aifp->command);
-
-		if (aif_command == AifCmdDriverNotify ||
-		    aif_command == AifCmdEventNotify ||
-		    aif_command == AifCmdJobProgress)
-			(void) aac_handle_aif(softs, aifp);
+		if (size > AAC_FIB_DATASIZE) size = AAC_FIB_DATASIZE;
+		dataptr = &slotp->fibp->data[0];
+		while (size) {
+			for (i = 0; i < 16; ++i) {
+				if (size) {
+					data[i] = ddi_get8(acc, dataptr);
+					++dataptr;
+					--size;
+				} else {
+					data[i] = 0;
+				}
+			}
+			AACDB_PRINT(softs, CE_NOTE, "0x%02x 0x%02x 0x%02x 0x%02x 0x%02x 0x%02x 0x%02x 0x%02x 0x%02x 0x%02x 0x%02x 0x%02x 0x%02x 0x%02x 0x%02x 0x%02x",
+				data[0], data[1], data[2], data[3],
+				data[4], data[5], data[6], data[7],
+				data[8], data[9], data[10], data[11],
+				data[12], data[13], data[14], data[15]);
+		}
 	}
-}
-
-/*
- * Timeout recovery
- */
-/*ARGSUSED*/
-static void
-aac_cmd_timeout(struct aac_softstate *softs, struct aac_cmd *acp)
-{
-#ifdef DEBUG
-	acp->fib_flags |= AACDB_FLAGS_FIB_TIMEOUT;
-	AACDB_PRINT(softs, CE_WARN, "acp %p timed out", acp);
-	AACDB_PRINT_FIB(softs, acp->slotp);
 #endif
 
+
 	/*
 	 * Besides the firmware in unhealthy state, an overloaded
 	 * adapter may also incur pkt timeout.
@@ -6596,18 +6524,18 @@
 	 * to perform IOs. So the adapter is doing a build on a RAID-5
 	 * while being required longer completion times should be
 	 * tolerated.
-	 */
-	switch (aac_do_reset(softs)) {
-	case AAC_IOP_RESET_SUCCEED:
-		aac_abort_iocmds(softs, AAC_IOCMD_OUTSTANDING, NULL, CMD_RESET);
+	 */  
+	rval = aac_do_reset(softs);
+	if (rval == AACOK) {
+		aac_abort_iocmds(softs, AAC_IOCMD_OUTSTANDING, NULL,
+		    CMD_RESET);
 		aac_start_waiting_io(softs);
-		break;
-	case AAC_IOP_RESET_FAILED:
-		/* Abort all waiting cmds when adapter is dead */
-		aac_abort_iocmds(softs, AAC_IOCMD_ALL, NULL, CMD_TIMEOUT);
-		break;
-	case AAC_IOP_RESET_ABNORMAL:
+	} else if (rval == AACOK2) {
 		aac_start_waiting_io(softs);
+	} else {
+		/* Abort all waiting cmds when adapter is dead */
+		aac_abort_iocmds(softs, AAC_IOCMD_ALL, NULL,
+		    CMD_TIMEOUT);
 	}
 }
 
